use std::collections::HashSet;

use crate::State;

pub fn print(state: &State, tag: &Option<String>) {
    match tag {
        Some(tag) => print_recursion(&state, &mut HashSet::new(), &tag, 0),
        None => {
            for tag in {
                let mut keys = state.tags.keys().collect::<Vec<_>>();
                keys.sort();
                keys
            } {
                let mut encountered = HashSet::new();
                print_recursion(&state, &mut encountered, tag, 0);
            }
        }
    }
}

fn print_recursion(state: &State, encountered: &mut HashSet<String>, tag: &str, level: u64) {
    let mut out = String::new();
    for _ in 0..level {
        out += "    ";
    }
    out += "|-";
    out += tag;
    println!("{out}");
    if encountered.contains(tag) {
        return;
    }
    encountered.insert(tag.to_string());
    for tag in &state.tags[tag] {
        print_recursion(state, encountered, tag, level + 1);
    }
}
