use std::collections::HashSet;

use tracing::{info, warn};

use crate::State;

pub fn tag(state: &mut State, tag: &String, objects: &Vec<String>) {
    if state.tags.get(tag).is_none() {
        info!("Adding {tag} to .state.json");
        state.tags.insert(tag.to_string(), HashSet::new());
    }
    for object in objects {
        if state.tags.get(object).is_none() {
            warn!("No {object} in .state.json");
            continue;
        }
        state.tags.get_mut(object).unwrap().insert(tag.to_string());
    }
}
