use clap::Parser;
use color_eyre::eyre::Result;

mod cli;
mod commands;
mod traits;
mod types;
mod gui;

use types::*;

fn main() -> Result<()> {
    color_eyre::install()?;
    tracing_subscriber::fmt().init();

    let flags = cli::Cli::parse();

    match &flags.command {
        Some(_) => cli::run(&flags),
        None => gui::run(&flags),
    }
}
